{-# OPTIONS -fglasgow-exts #-}
-- Roshan P. James, Amr Sabry
-- rpjames@cs.indiana.edu, sabry@cs.indiana.edu

module AccYield (Iterator(..), Yield, yield, run) where 

-- Based on the original implentation by Michael Adams

data Iterator i o r = Result r
	            | Susp o (i -> Iterator i o r)
type Yield = Iterator

instance Monad (Yield i o) where
    return = Result
    (Result v) >>= f = f v
    (Susp v k) >>= f = Susp v ( \x -> (k x) >>= f )


class Monad m => MonadYield i o m | m -> i, m -> o where
    yield :: o -> m i
    run :: m r -> Iterator i o r

instance MonadYield i o (Yield i o) where
    yield v = Susp v return
    run = id
