-- Roshan P. James, Amr Sabry
-- rpjames@cs.indiana.edu, sabry@cs.indiana.edu

import CpsYield
import Debug.Trace


-------------------------------------------------------------
-- This is shift-reset built over the normal "Yield i o r" type.

data C i ans r = C { unC :: SR i ans r }
type SR i ans r = Yield i ((i -> ans) -> C i ans ans) r

shift :: ((a -> ans) -> SR a ans ans) -> SR a ans a
shift e = yield (C . e)

reset :: SR a ans ans -> ans
reset e = interp (run e)
    where 
      interp (Susp f k) = reset $ unC $ f $ \x -> interp (k x)
      interp (Result r) = r


------------------------------------------------------------
-- Ex. 

trace_show x = trace (show x) x

testsr :: String
testsr =  if reset (do a <- (shift use)
                       return (trace_show (a == 0)))
          then "true"
          else "false"
                        
    where 
      use k = return (not (k 1))

